// Code generated by gowrap. DO NOT EDIT.
// template: ..\..\..\assets\templates\middleware\telemetry
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/roles -i Roles -t ..\..\..\assets\templates\middleware\telemetry -o telemetry_middleware.go -l ""

// source template: https://github.com/hexdigest/gowrap/blob/master/templates/opentelemetry

import (
	"context"
	"time"

	"git.perx.ru/perxis/perxis-go/pkg/roles"
	"git.perx.ru/perxis/perxis-go/pkg/telemetry/metrics"
	"go.opentelemetry.io/otel"
	"go.opentelemetry.io/otel/attribute"
	otelmetric "go.opentelemetry.io/otel/metric"
	"go.opentelemetry.io/otel/trace"
)

// telemetryMiddleware implements roles.Roles interface instrumented with opentracing spans
type telemetryMiddleware struct {
	roles.Roles
	_instance      string
	requestMetrics *metrics.RequestMetrics
	_spanDecorator func(span trace.Span, params, results map[string]interface{})
}

// TelemetryMiddleware returns telemetryMiddleware
func TelemetryMiddleware(base roles.Roles, instance string, spanDecorator ...func(span trace.Span, params, results map[string]interface{})) telemetryMiddleware {
	requestMetrics, err := metrics.GetRequestMetrics()
	if err != nil {
		panic(err)
	}

	d := telemetryMiddleware{
		Roles:          base,
		_instance:      instance,
		requestMetrics: requestMetrics,
	}

	if len(spanDecorator) > 0 && spanDecorator[0] != nil {
		d._spanDecorator = spanDecorator[0]
	}

	return d
}

// Create implements roles.Roles
func (_d telemetryMiddleware) Create(ctx context.Context, role *roles.Role) (created *roles.Role, err error) {
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(
		attribute.String("service", "Roles"),
		attribute.String("method", "Create"),
	))

	_d.requestMetrics.Total.Add(ctx, 1, attributes)

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Roles.Create")

	defer func() {
		_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

		if _d._spanDecorator != nil {
			_d._spanDecorator(_span, map[string]interface{}{
				"ctx":  ctx,
				"role": role}, map[string]interface{}{
				"created": created,
				"err":     err})
		} else if err != nil {
			_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

			_span.RecordError(err)
			_span.SetAttributes(attribute.String("event", "error"))
			_span.SetAttributes(attribute.String("message", err.Error()))
		}

		_span.End()
	}()
	return _d.Roles.Create(ctx, role)
}

// Delete implements roles.Roles
func (_d telemetryMiddleware) Delete(ctx context.Context, spaceId string, roleId string) (err error) {
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(
		attribute.String("service", "Roles"),
		attribute.String("method", "Delete"),
	))

	_d.requestMetrics.Total.Add(ctx, 1, attributes)

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Roles.Delete")

	defer func() {
		_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

		if _d._spanDecorator != nil {
			_d._spanDecorator(_span, map[string]interface{}{
				"ctx":     ctx,
				"spaceId": spaceId,
				"roleId":  roleId}, map[string]interface{}{
				"err": err})
		} else if err != nil {
			_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

			_span.RecordError(err)
			_span.SetAttributes(attribute.String("event", "error"))
			_span.SetAttributes(attribute.String("message", err.Error()))
		}

		_span.End()
	}()
	return _d.Roles.Delete(ctx, spaceId, roleId)
}

// Get implements roles.Roles
func (_d telemetryMiddleware) Get(ctx context.Context, spaceId string, roleId string) (role *roles.Role, err error) {
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(
		attribute.String("service", "Roles"),
		attribute.String("method", "Get"),
	))

	_d.requestMetrics.Total.Add(ctx, 1, attributes)

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Roles.Get")

	defer func() {
		_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

		if _d._spanDecorator != nil {
			_d._spanDecorator(_span, map[string]interface{}{
				"ctx":     ctx,
				"spaceId": spaceId,
				"roleId":  roleId}, map[string]interface{}{
				"role": role,
				"err":  err})
		} else if err != nil {
			_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

			_span.RecordError(err)
			_span.SetAttributes(attribute.String("event", "error"))
			_span.SetAttributes(attribute.String("message", err.Error()))
		}

		_span.End()
	}()
	return _d.Roles.Get(ctx, spaceId, roleId)
}

// List implements roles.Roles
func (_d telemetryMiddleware) List(ctx context.Context, spaceId string) (roles []*roles.Role, err error) {
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(
		attribute.String("service", "Roles"),
		attribute.String("method", "List"),
	))

	_d.requestMetrics.Total.Add(ctx, 1, attributes)

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Roles.List")

	defer func() {
		_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

		if _d._spanDecorator != nil {
			_d._spanDecorator(_span, map[string]interface{}{
				"ctx":     ctx,
				"spaceId": spaceId}, map[string]interface{}{
				"roles": roles,
				"err":   err})
		} else if err != nil {
			_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

			_span.RecordError(err)
			_span.SetAttributes(attribute.String("event", "error"))
			_span.SetAttributes(attribute.String("message", err.Error()))
		}

		_span.End()
	}()
	return _d.Roles.List(ctx, spaceId)
}

// Update implements roles.Roles
func (_d telemetryMiddleware) Update(ctx context.Context, role *roles.Role) (err error) {
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(
		attribute.String("service", "Roles"),
		attribute.String("method", "Update"),
	))

	_d.requestMetrics.Total.Add(ctx, 1, attributes)

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Roles.Update")

	defer func() {
		_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

		if _d._spanDecorator != nil {
			_d._spanDecorator(_span, map[string]interface{}{
				"ctx":  ctx,
				"role": role}, map[string]interface{}{
				"err": err})
		} else if err != nil {
			_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

			_span.RecordError(err)
			_span.SetAttributes(attribute.String("event", "error"))
			_span.SetAttributes(attribute.String("message", err.Error()))
		}

		_span.End()
	}()
	return _d.Roles.Update(ctx, role)
}
